#
# NDSCreate.pl
#
# This script demonstrates how to set up an service to add users
# or other objects to NDS with NDSm.
#
# Copyright (c) 1997 Steinar Kleven, all rights reserved
#
#	Please adjust the 'require ../cgi-lib.pl' to 
#  match this scripts relative location to cgi-lib.pl on your system.
#


BEGIN {$| = 1; require "../cgi-lib.pl"; }

use strict;
use vars qw($C $Start $Flags %in %Images $this_script);

%Images = ('Printer' => "$ibase/Printer.gif",
            'Computer' => "$ibase/Computer.gif",
            'Country' => "$ibase/Country.gif",
				'Group' => "$ibase/Group.gif",
				'NCP Server' => "$ibase/NCP_Server.gif",
				'Organizational Unit' => "$ibase/Organizational_Unit.gif",
				'Print Server' => "$ibase/Print_Server.gif",
				'Profile' => "$ibase/Profile.gif",
				'Queue' => "$ibase/Queue.gif",
				'Template' => "$ibase/Template.gif",
				'Unknown' => "$ibase/Unknown.gif",
				'User' => "$ibase/User.gif",
				'Volume' => "$ibase/Volume.gif",
				'Organization' => "$ibase/Organization.gif",
				'App:Application' => "$ibase/App_Application.gif",
				'Application (Windows 3.x)' => "$ibase/Application_win3.gif");


$this_script = "/cgi-bin/NDSm-demo/$0";

use NDSm::NDSContext;
use NDSm::Buf_T;



sub MyDie {
   my ($Object, $Msg) = @_;
   my $Err = $Object->LastErr();
   die("$Msg, error $Err");
}

sub MyEnd { 
	print &HtmlBot;
	exit();
}


sub UserForm {
	print "<FORM ACTION=\"$this_script\" METHOD=\"POST\">\n";
   print "<INPUT TYPE=HIDDEN NAME=task VALUE=\"$in{'task'}\">\n";
   print "<INPUT TYPE=HIDDEN NAME=context VALUE=\"$in{'context'}\">\n";
   print  << 'FORM_END';
  <FONT COLOR="FF0000">* => mandatory</FONT><BR>
  <pre>
  User Name:    <INPUT NAME="objname" VALUE="" SIZE=16 MAXLENGTH=15>*
  Last name:    <INPUT NAME="last name" VALUE="" SIZE=31 MAXLENGTH=30>*
  Given name:   <INPUT NAME="given name" VALUE="" SIZE=31 MAXLENGTH=30>
  Password:     <INPUT TYPE=PASSWORD NAME="password" VALUE="" SIZE=31 MAXLENGTH=30>
  Description:  <INPUT NAME="description" VALUE="" SIZE=61 MAXLENGTH=60>
  </pre>
  <INPUT TYPE="Submit" Value="Create">
  <INPUT TYPE="Reset" Value="Clear">
  </form>
FORM_END
}


sub CreateObject() {




}


sub PrintForm {
	my $objtype = $in{'objtype'};
	UserForm() if ($objtype eq 'User');
	GroupForm() if ($objtype eq 'Group');
}


#######
# Execution start here
#######

# Get parameters
&ReadParse(\*in);
print &HtmlTop("NDSm create demo");

if ($in{'objectname'} && ($in{'task'} eq 'create')){
   CreateObject(); 
   MyEnd();
}

UserForm();
&MyEnd();
if ($in{'task'} && $in{'objtype'} && $in{'context'})
{
	PrintForm ();
	&MyEnd();
}


$C = new NDSm::NDSContext;


# We can't do anything if we're not logged on
if (!$C->IsDSAuthenticated())
{
  print("You're not logged on, bailing out!!") ;
  &Myend();
}


# Make sure we always get full name and context
# when we call CanonicalizeName() in StatTree 
# We also want those nice O=, OU= ....
$Flags = $C->GetContext("DCK_FLAGS");
$Flags |= $C->GetConst("DCV_CANONICALIZE_NAMES", 0);
# $Flags &= ~ $C->GetConst("DCV_TYPELESS_NAMES", 0);
$C->SetContext("DCK_FLAGS", $Flags);

$C->SetContext("DCK_NAME_CONTEXT", $in{'context'});
print "<P><HR><P>\n";

print "<HR><p>Powered by <A HREF=\"http://www.ahs.hist.no/distr/NDSm\"><B>NDSm</B></A>\n";
&Myend();

__END__
